// Faan Tone Liu, Jan 29 2002
// A little program to show that arrays are really pointers

#include <iostream>
using namespace std;

void output_word(char *);

int main()
{
	char arr[80];  // arr is an array of chars, which we see is
	               // actually a constant pointer to a char
	char *aptr;    // aptr is just a plain old pointer to a char

	cout << "Type a word: " << endl;
	cin >> arr;

	output_word(arr);  // see? it's okay to pass arr as if
	                       // it were a char * (because it is!)

	aptr = arr;            // see?  You can assign arr to a
	                       // char *.  aptr now points to the
	                       // beginning of the array
	output_word(aptr); // as evidenced by the success of
	                       // this function call

	// But the following chokes the compiler.  Why? because
	// although arr is a pointer to a char, it's a CONSTANT
	// pointer, and thus cannot itself be altered to point
	// somewhere else
/*	arr = aptr;  */
	return 0;
}

void output_word(char *word)
{
	cout << "Here's what you typed: " << endl;
	cout << word << endl;
}
